# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulp_deb.configuration import Configuration


class DebAptPublication(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'repository_version': 'str',
        'repository': 'str',
        'simple': 'bool',
        'structured': 'bool',
        'signing_service': 'str'
    }

    attribute_map = {
        'repository_version': 'repository_version',
        'repository': 'repository',
        'simple': 'simple',
        'structured': 'structured',
        'signing_service': 'signing_service'
    }

    def __init__(self, repository_version=None, repository=None, simple=False, structured=False, signing_service=None, local_vars_configuration=None):  # noqa: E501
        """DebAptPublication - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._repository_version = None
        self._repository = None
        self._simple = None
        self._structured = None
        self._signing_service = None
        self.discriminator = None

        if repository_version is not None:
            self.repository_version = repository_version
        if repository is not None:
            self.repository = repository
        if simple is not None:
            self.simple = simple
        if structured is not None:
            self.structured = structured
        if signing_service is not None:
            self.signing_service = signing_service

    @property
    def repository_version(self):
        """Gets the repository_version of this DebAptPublication.  # noqa: E501


        :return: The repository_version of this DebAptPublication.  # noqa: E501
        :rtype: str
        """
        return self._repository_version

    @repository_version.setter
    def repository_version(self, repository_version):
        """Sets the repository_version of this DebAptPublication.


        :param repository_version: The repository_version of this DebAptPublication.  # noqa: E501
        :type: str
        """

        self._repository_version = repository_version

    @property
    def repository(self):
        """Gets the repository of this DebAptPublication.  # noqa: E501

        A URI of the repository to be published.  # noqa: E501

        :return: The repository of this DebAptPublication.  # noqa: E501
        :rtype: str
        """
        return self._repository

    @repository.setter
    def repository(self, repository):
        """Sets the repository of this DebAptPublication.

        A URI of the repository to be published.  # noqa: E501

        :param repository: The repository of this DebAptPublication.  # noqa: E501
        :type: str
        """

        self._repository = repository

    @property
    def simple(self):
        """Gets the simple of this DebAptPublication.  # noqa: E501

        Activate simple publishing mode (all packages in one release component).  # noqa: E501

        :return: The simple of this DebAptPublication.  # noqa: E501
        :rtype: bool
        """
        return self._simple

    @simple.setter
    def simple(self, simple):
        """Sets the simple of this DebAptPublication.

        Activate simple publishing mode (all packages in one release component).  # noqa: E501

        :param simple: The simple of this DebAptPublication.  # noqa: E501
        :type: bool
        """

        self._simple = simple

    @property
    def structured(self):
        """Gets the structured of this DebAptPublication.  # noqa: E501

        Activate structured publishing mode.  # noqa: E501

        :return: The structured of this DebAptPublication.  # noqa: E501
        :rtype: bool
        """
        return self._structured

    @structured.setter
    def structured(self, structured):
        """Sets the structured of this DebAptPublication.

        Activate structured publishing mode.  # noqa: E501

        :param structured: The structured of this DebAptPublication.  # noqa: E501
        :type: bool
        """

        self._structured = structured

    @property
    def signing_service(self):
        """Gets the signing_service of this DebAptPublication.  # noqa: E501

        Sign Release files with this signing key  # noqa: E501

        :return: The signing_service of this DebAptPublication.  # noqa: E501
        :rtype: str
        """
        return self._signing_service

    @signing_service.setter
    def signing_service(self, signing_service):
        """Sets the signing_service of this DebAptPublication.

        Sign Release files with this signing key  # noqa: E501

        :param signing_service: The signing_service of this DebAptPublication.  # noqa: E501
        :type: str
        """

        self._signing_service = signing_service

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DebAptPublication):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DebAptPublication):
            return True

        return self.to_dict() != other.to_dict()
